#!/usr/bin/env python3

import pyodbc
import psycopg2

accounts = list()

# mssql read
server = '{{ mssql_server }}'
port = '1445'
uid = 'wlan_radius_prod'
pwd = '{{ passwords.freeradius_mssql_wlankonten }}'
database = 'wlankonten_prod'
table = 'wlankonten_active'

con_string = ('DRIVER=FreeTDS;SERVER=%s;PORT=%s;DATABASE=%s;UID=%s;PWD=%s;TDS_VERSION=8.0;Encryption=require' % (server, port, database, uid, pwd))
query = ('SELECT login,password from %s' % table)

conn = pyodbc.connect(con_string)
cursor = conn.cursor()
cursor.execute(query)
rows = cursor.fetchall()
for row in rows:
    accounts.append({ 'username': row.login, 'value': row.password })
conn.close()
account_tuple = tuple(accounts)

# postgresql write
user='radius'
password='{{ passwords.freeradius_postgres_radius }}'
database='radius'

with psycopg2.connect(dbname=database, user=user, password=password) as conn:
    cursor = conn.cursor()
    cursor.execute("""DELETE FROM {{ postgres_table_gast_accounts }}""")
    # cursor.execute("""ALTER SEQUENCE {{ postgres_table_gast_accounts }}_id_seq RESTART WITH 1""")
    cursor.executemany("""INSERT INTO {{ postgres_table_gast_accounts }} (username, attribute, op, value) VALUES (%(username)s, 'Cleartext-Password', ':=', %(value)s)""", account_tuple)
